(ns traces
  (:require [cljs.nodejs :as node]
            [cljs.core.async :refer [go]]
            [cljs.core.async.interop :refer-macros [<p!]]))

;;;; WHAT IS THIS KEY DOING IN HERE?
;;; This is a key with minimum access. It's used to generate events on the CLI usage.
;;; The same way Google Analytics store the key to send events in the browser.
;;; The only harm possible with this key is some bad actor generating fake events.
;;; It would be nice if one did, as our systems would get some free testing.
(def write-key "6019c7f5339b93f82f853e9d83d2376e")

(def beeline (node/require "honeycomb-beeline"))

(def event (beeline. (clj->js {:writeKey write-key
                               :dataset "runops"
                               :serviceName "runops-cli"})))

(defn add-context [c]
  (doto event (.addContext (clj->js c))))

(defn close [& _]
  (<p! (.flush event))
  (node/process.exit 0))

(defn flush-event [data]
  (go (<p! (.flush event)))
  data)
